diff --git a/base/server/src/engine/pkihelper.py b/base/server/src/engine/pkihelper.py
index 8ca83be67ae5bf4c4eabc023253c342eac278d89..e91932720dd94d521592e5e78a4170742bcf8558 100644
--- a/base/server/src/engine/pkihelper.py
+++ b/base/server/src/engine/pkihelper.py
@@ -48,8 +48,6 @@ if selinux.is_selinux_enabled():
 
 # PKI Deployment Imports
 import pkiconfig as config
-from pkiconfig import pki_master_dict as master
-from pkiconfig import pki_slots_dict as slots
 from pkiconfig import pki_selinux_config_ports as ports
 import pkimanifest as manifest
 import pkimessages as log
@@ -129,8 +127,12 @@ def pki_copytree(src, dst, symlinks = False, ignore = None):
     if errors:
         raise Error, errors
 
-# PKI Deployment Identity Class
-class identity:
+class _Identity:
+    """PKI Deployment Identity Class"""
+    
+    def __init__(self, pki_master_dict):
+        self.master_dict = pki_master_dict
+        
     def __add_gid(self, pki_group):
         pki_gid = None
         try:
@@ -263,7 +265,7 @@ class identity:
 
     def get_uid(self, critical_failure = True):
         try:
-            pki_uid = master['pki_uid']
+            pki_uid = self.master_dict['pki_uid']
         except KeyError as exc:
             config.pki_log.error(log.PKI_KEYERROR_1, exc,
                                  extra = config.PKI_INDENTATION_LEVEL_2)
@@ -273,7 +275,7 @@ class identity:
 
     def get_gid(self, critical_failure = True):
         try:
-            pki_gid = master['pki_gid']
+            pki_gid = self.master_dict['pki_gid']
         except KeyError as exc:
             config.pki_log.error(log.PKI_KEYERROR_1, exc,
                                  extra = config.PKI_INDENTATION_LEVEL_2)
@@ -287,7 +289,7 @@ class identity:
                                  extra = config.PKI_INDENTATION_LEVEL_2)
             # id -u <name>
             pki_uid = getpwnam(name)[2]
-            master['pki_uid'] = pki_uid
+            self.master_dict['pki_uid'] = pki_uid
             config.pki_log.debug(log.PKIHELPER_UID_2, name, pki_uid,
                                  extra = config.PKI_INDENTATION_LEVEL_3)
         except KeyError as exc:
@@ -303,7 +305,7 @@ class identity:
                                  extra = config.PKI_INDENTATION_LEVEL_2)
             # id -g <name>
             pki_gid = getgrnam(name)[2]
-            master['pki_gid'] = pki_gid
+            self.master_dict['pki_gid'] = pki_gid
             config.pki_log.debug(log.PKIHELPER_GID_2, name, pki_gid,
                                  extra = config.PKI_INDENTATION_LEVEL_3)
         except KeyError as exc:
@@ -313,272 +315,279 @@ class identity:
                 raise
         return pki_gid
 
-
-# PKI Deployment Namespace Class
-class namespace:
+class _Namespace:
+    """PKI Deployment Namespace Class"""
+    
     # Silently verify that the selected 'pki_instance_name' will
     # NOT produce any namespace collisions
+    def __init__(self, pki_master_dict):
+        self.master_dict = pki_master_dict
+    
     def collision_detection(self):
         # Run simple checks for pre-existing namespace collisions
-        if os.path.exists(master['pki_instance_path']):
-            if os.path.exists(master['pki_subsystem_path']):
+        if os.path.exists(self.master_dict['pki_instance_path']):
+            if os.path.exists(self.master_dict['pki_subsystem_path']):
                 # Top-Level PKI base path collision
                 config.pki_log.error(
                     log.PKIHELPER_NAMESPACE_COLLISION_2,
-                    master['pki_instance_name'],
-                    master['pki_instance_path'],
+                    self.master_dict['pki_instance_name'],
+                    self.master_dict['pki_instance_path'],
                     extra = config.PKI_INDENTATION_LEVEL_2)
-                raise Exception(log.PKIHELPER_NAMESPACE_COLLISION_2 % (master['pki_instance_name'],
-                                                                    master['pki_instance_path']))
+                raise Exception(log.PKIHELPER_NAMESPACE_COLLISION_2 % (self.master_dict['pki_instance_name'],
+                                                                       self.master_dict['pki_instance_path']))
         else:
-            if os.path.exists(master['pki_target_tomcat_conf_instance_id']):
+            if os.path.exists(self.master_dict['pki_target_tomcat_conf_instance_id']):
                 # Top-Level "/etc/sysconfig" path collision
                 config.pki_log.error(
                     log.PKIHELPER_NAMESPACE_COLLISION_2,
-                    master['pki_instance_name'],
-                    master['pki_target_tomcat_conf_instance_id'],
+                    self.master_dict['pki_instance_name'],
+                    self.master_dict['pki_target_tomcat_conf_instance_id'],
                     extra = config.PKI_INDENTATION_LEVEL_2)
-                raise Exception(log.PKIHELPER_NAMESPACE_COLLISION_2 % (master['pki_instance_name'],
-                                                                      master['pki_target_tomcat_conf_instance_id']))
-            if os.path.exists(master['pki_cgroup_systemd_service']):
+                raise Exception(log.PKIHELPER_NAMESPACE_COLLISION_2 % (self.master_dict['pki_instance_name'],
+                                                                       self.master_dict['pki_target_tomcat_conf_instance_id']))
+            if os.path.exists(self.master_dict['pki_cgroup_systemd_service']):
                 # Systemd cgroup path collision
                 config.pki_log.error(
                     log.PKIHELPER_NAMESPACE_COLLISION_2,
-                    master['pki_instance_name'],
-                    master['pki_cgroup_systemd_service_path'],
+                    self.master_dict['pki_instance_name'],
+                    self.master_dict['pki_cgroup_systemd_service_path'],
                     extra = config.PKI_INDENTATION_LEVEL_2)
-                raise Exception(log.PKIHELPER_NAMESPACE_COLLISION_2 % (master['pki_instance_name'],
-                                                                      master['pki_cgroup_systemd_service_path']))
-            if os.path.exists(master['pki_cgroup_cpu_systemd_service']):
+                raise Exception(log.PKIHELPER_NAMESPACE_COLLISION_2 % (self.master_dict['pki_instance_name'],
+                                                                       self.master_dict['pki_cgroup_systemd_service_path']))
+            if os.path.exists(self.master_dict['pki_cgroup_cpu_systemd_service']):
                 # Systemd cgroup CPU path collision
                 config.pki_log.error(
                     log.PKIHELPER_NAMESPACE_COLLISION_2,
-                    master['pki_instance_name'],
-                    master['pki_cgroup_cpu_systemd_service_path'],
+                    self.master_dict['pki_instance_name'],
+                    self.master_dict['pki_cgroup_cpu_systemd_service_path'],
                     extra = config.PKI_INDENTATION_LEVEL_2)
-                raise Exception(log.PKIHELPER_NAMESPACE_COLLISION_2 % (master['pki_instance_name'],
-                                                                      master['pki_cgroup_cpu_systemd_service_path']))
-        if os.path.exists(master['pki_instance_log_path']) and\
-           os.path.exists(master['pki_subsystem_log_path']):
+                raise Exception(log.PKIHELPER_NAMESPACE_COLLISION_2 % (self.master_dict['pki_instance_name'],
+                                                                       self.master_dict['pki_cgroup_cpu_systemd_service_path']))
+        if os.path.exists(self.master_dict['pki_instance_log_path']) and\
+           os.path.exists(self.master_dict['pki_subsystem_log_path']):
             # Top-Level PKI log path collision
             config.pki_log.error(
                 log.PKIHELPER_NAMESPACE_COLLISION_2,
-                master['pki_instance_name'],
-                master['pki_instance_log_path'],
+                self.master_dict['pki_instance_name'],
+                self.master_dict['pki_instance_log_path'],
                 extra = config.PKI_INDENTATION_LEVEL_2)
-            raise Exception(log.PKIHELPER_NAMESPACE_COLLISION_2 % (master['pki_instance_name'],
-                                                                  master['pki_instance_log_path']))
-        if os.path.exists(master['pki_instance_configuration_path']) and\
-           os.path.exists(master['pki_subsystem_configuration_path']):
+            raise Exception(log.PKIHELPER_NAMESPACE_COLLISION_2 % (self.master_dict['pki_instance_name'],
+                                                                  self.master_dict['pki_instance_log_path']))
+        if os.path.exists(self.master_dict['pki_instance_configuration_path']) and\
+           os.path.exists(self.master_dict['pki_subsystem_configuration_path']):
             # Top-Level PKI configuration path collision
             config.pki_log.error(
                 log.PKIHELPER_NAMESPACE_COLLISION_2,
-                master['pki_instance_name'],
-                master['pki_instance_configuration_path'],
+                self.master_dict['pki_instance_name'],
+                self.master_dict['pki_instance_configuration_path'],
                 extra = config.PKI_INDENTATION_LEVEL_2)
-            raise Exception(log.PKIHELPER_NAMESPACE_COLLISION_2 % (master['pki_instance_name'],
-                                                                  master['pki_instance_configuration_path']))
-        if os.path.exists(master['pki_instance_registry_path']) and\
-           os.path.exists(master['pki_subsystem_registry_path']):
+            raise Exception(log.PKIHELPER_NAMESPACE_COLLISION_2 % (self.master_dict['pki_instance_name'],
+                                                                  self.master_dict['pki_instance_configuration_path']))
+        if os.path.exists(self.master_dict['pki_instance_registry_path']) and\
+           os.path.exists(self.master_dict['pki_subsystem_registry_path']):
             # Top-Level PKI registry path collision
             config.pki_log.error(
                 log.PKIHELPER_NAMESPACE_COLLISION_2,
-                master['pki_instance_name'],
-                master['pki_instance_registry_path'],
+                self.master_dict['pki_instance_name'],
+                self.master_dict['pki_instance_registry_path'],
                 extra = config.PKI_INDENTATION_LEVEL_2)
-            raise Exception(log.PKIHELPER_NAMESPACE_COLLISION_2 % (master['pki_instance_name'],
-                                                                  master['pki_instance_registry_path']))
+            raise Exception(log.PKIHELPER_NAMESPACE_COLLISION_2 % (self.master_dict['pki_instance_name'],
+                                                                  self.master_dict['pki_instance_registry_path']))
         # Run simple checks for reserved name namespace collisions
-        if master['pki_instance_name'] in config.PKI_BASE_RESERVED_NAMES:
+        if self.master_dict['pki_instance_name'] in config.PKI_BASE_RESERVED_NAMES:
             # Top-Level PKI base path reserved name collision
             config.pki_log.error(
                 log.PKIHELPER_NAMESPACE_RESERVED_NAME_2,
-                master['pki_instance_name'],
-                master['pki_instance_path'],
+                self.master_dict['pki_instance_name'],
+                self.master_dict['pki_instance_path'],
                 extra = config.PKI_INDENTATION_LEVEL_2)
-            raise Exception(log.PKIHELPER_NAMESPACE_RESERVED_NAME_2 % (master['pki_instance_name'],
-                                                                      master['pki_instance_path']))
+            raise Exception(log.PKIHELPER_NAMESPACE_RESERVED_NAME_2 % (self.master_dict['pki_instance_name'],
+                                                                      self.master_dict['pki_instance_path']))
         # No need to check for reserved name under Top-Level PKI log path
-        if master['pki_instance_name'] in config.PKI_CONFIGURATION_RESERVED_NAMES:
+        if self.master_dict['pki_instance_name'] in config.PKI_CONFIGURATION_RESERVED_NAMES:
             # Top-Level PKI configuration path reserved name collision
             config.pki_log.error(
                 log.PKIHELPER_NAMESPACE_RESERVED_NAME_2,
-                master['pki_instance_name'],
-                master['pki_instance_configuration_path'],
+                self.master_dict['pki_instance_name'],
+                self.master_dict['pki_instance_configuration_path'],
                 extra = config.PKI_INDENTATION_LEVEL_2)
-            raise Exception(log.PKIHELPER_NAMESPACE_RESERVED_NAME_2 % (master['pki_instance_name'],
-                                                                      master['pki_instance_configuration_path']))
-        if master['pki_subsystem'] in config.PKI_APACHE_SUBSYSTEMS:
+            raise Exception(log.PKIHELPER_NAMESPACE_RESERVED_NAME_2 % (self.master_dict['pki_instance_name'],
+                                                                      self.master_dict['pki_instance_configuration_path']))
+        if self.master_dict['pki_subsystem'] in config.PKI_APACHE_SUBSYSTEMS:
             # Top-Level Apache PKI registry path reserved name collision
-            if master['pki_instance_name'] in\
+            if self.master_dict['pki_instance_name'] in\
                config.PKI_APACHE_REGISTRY_RESERVED_NAMES:
                 config.pki_log.error(
                     log.PKIHELPER_NAMESPACE_RESERVED_NAME_2,
-                    master['pki_instance_name'],
-                    master['pki_instance_registry_path'],
+                    self.master_dict['pki_instance_name'],
+                    self.master_dict['pki_instance_registry_path'],
                     extra = config.PKI_INDENTATION_LEVEL_2)
-                raise Exception(log.PKIHELPER_NAMESPACE_RESERVED_NAME_2 % (master['pki_instance_name'],
-                                                                          master['pki_instance_registry_path']))
-        elif master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
+                raise Exception(log.PKIHELPER_NAMESPACE_RESERVED_NAME_2 % (self.master_dict['pki_instance_name'],
+                                                                          self.master_dict['pki_instance_registry_path']))
+        elif self.master_dict['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
             # Top-Level Tomcat PKI registry path reserved name collision
-            if master['pki_instance_name'] in\
+            if self.master_dict['pki_instance_name'] in\
                config.PKI_TOMCAT_REGISTRY_RESERVED_NAMES:
                 config.pki_log.error(
                     log.PKIHELPER_NAMESPACE_RESERVED_NAME_2,
-                    master['pki_instance_name'],
-                    master['pki_instance_registry_path'],
+                    self.master_dict['pki_instance_name'],
+                    self.master_dict['pki_instance_registry_path'],
                     extra = config.PKI_INDENTATION_LEVEL_2)
-                raise Exception(log.PKIHELPER_NAMESPACE_RESERVED_NAME_2 % (master['pki_instance_name'],
-                                                                          master['pki_instance_registry_path']))
+                raise Exception(log.PKIHELPER_NAMESPACE_RESERVED_NAME_2 % (self.master_dict['pki_instance_name'],
+                                                                          self.master_dict['pki_instance_registry_path']))
 
 
-# PKI Deployment Configuration File Class
-class configuration_file:
+class _ConfigurationFile:
+    """PKI Deployment Configuration File Class"""    
+    
+    def __init__(self, pki_master_dict):
+        self.master_dict = pki_master_dict
+        
     def log_configuration_url(self):
         # NOTE:  This is the one and only parameter containing a sensitive
         #        parameter that may be stored in a log file.
         config.pki_log.info(log.PKI_CONFIGURATION_WIZARD_URL_1,
-                            master['pki_configuration_url'],
+                            self.master_dict['pki_configuration_url'],
                             extra = config.PKI_INDENTATION_LEVEL_2)
         config.pki_log.info(log.PKI_CONFIGURATION_WIZARD_RESTART_1,
-                            master['pki_registry_initscript_command'],
+                            self.master_dict['pki_registry_initscript_command'],
                             extra = config.PKI_INDENTATION_LEVEL_2)
 
     def display_configuration_url(self):
         # NOTE:  This is the one and only parameter containing a sensitive
         #        parameter that may be displayed to the screen.
-        print log.PKI_CONFIGURATION_URL_1 % master['pki_configuration_url']
+        print log.PKI_CONFIGURATION_URL_1 % self.master_dict['pki_configuration_url']
         print
         print log.PKI_CONFIGURATION_RESTART_1 % \
-              master['pki_registry_initscript_command']
+              self.master_dict['pki_registry_initscript_command']
         print
 
     def verify_sensitive_data(self):
         # Silently verify the existence of 'sensitive' data
-        if master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
+        if self.master_dict['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
             # Verify existence of Directory Server Password (ALWAYS)
-            if not master.has_key('pki_ds_password') or\
-               not len(master['pki_ds_password']):
+            if not self.master_dict.has_key('pki_ds_password') or\
+               not len(self.master_dict['pki_ds_password']):
                 config.pki_log.error(
                     log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
                     "pki_ds_password",
-                    master['pki_user_deployment_cfg'],
+                    self.master_dict['pki_user_deployment_cfg'],
                     extra = config.PKI_INDENTATION_LEVEL_2)
                 raise Exception(log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 % ("pki_ds_password",
-                                                                                     master['pki_user_deployment_cfg']))
+                                                                                     self.master_dict['pki_user_deployment_cfg']))
             # Verify existence of Admin Password (except for Clones)
-            if not config.str2bool(master['pki_clone']):
-                if not master.has_key('pki_admin_password') or\
-                   not len(master['pki_admin_password']):
+            if not config.str2bool(self.master_dict['pki_clone']):
+                if not self.master_dict.has_key('pki_admin_password') or\
+                   not len(self.master_dict['pki_admin_password']):
                     config.pki_log.error(
                         log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
                         "pki_admin_password",
-                        master['pki_user_deployment_cfg'],
+                        self.master_dict['pki_user_deployment_cfg'],
                         extra = config.PKI_INDENTATION_LEVEL_2)
                     raise Exception(log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 % ("pki_admin_password",
-                                                                                         master['pki_user_deployment_cfg']))
+                                                                                         self.master_dict['pki_user_deployment_cfg']))
             # If required, verify existence of Backup Password
-            if config.str2bool(master['pki_backup_keys']):
-                if not master.has_key('pki_backup_password') or\
-                   not len(master['pki_backup_password']):
+            if config.str2bool(self.master_dict['pki_backup_keys']):
+                if not self.master_dict.has_key('pki_backup_password') or\
+                   not len(self.master_dict['pki_backup_password']):
                     config.pki_log.error(
                         log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
                         "pki_backup_password",
-                        master['pki_user_deployment_cfg'],
+                        self.master_dict['pki_user_deployment_cfg'],
                         extra = config.PKI_INDENTATION_LEVEL_2)
                     raise Exception(log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 % ("pki_backup_password",
-                                                                                         master['pki_user_deployment_cfg']))
+                                                                                         self.master_dict['pki_user_deployment_cfg']))
             # Verify existence of Client Pin for NSS client security databases
-            if not master.has_key('pki_client_database_password') or\
-               not len(master['pki_client_database_password']):
+            if not self.master_dict.has_key('pki_client_database_password') or\
+               not len(self.master_dict['pki_client_database_password']):
                 config.pki_log.error(
                     log.PKIHELPER_UNDEFINED_CLIENT_DATABASE_PASSWORD_2,
                     "pki_client_database_password",
-                    master['pki_user_deployment_cfg'],
+                    self.master_dict['pki_user_deployment_cfg'],
                     extra = config.PKI_INDENTATION_LEVEL_2)
                 raise Exception(log.PKIHELPER_UNDEFINED_CLIENT_DATABASE_PASSWORD_2 % ("pki_client_database_password",
-                                                                                     master['pki_user_deployment_cfg']))
+                                                                                     self.master_dict['pki_user_deployment_cfg']))
             # Verify existence of Client PKCS #12 Password for Admin Cert
-            if not master.has_key('pki_client_pkcs12_password') or\
-               not len(master['pki_client_pkcs12_password']):
+            if not self.master_dict.has_key('pki_client_pkcs12_password') or\
+               not len(self.master_dict['pki_client_pkcs12_password']):
                 config.pki_log.error(
                     log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
                     "pki_client_pkcs12_password",
-                    master['pki_user_deployment_cfg'],
+                    self.master_dict['pki_user_deployment_cfg'],
                     extra = config.PKI_INDENTATION_LEVEL_2)
                 raise Exception(log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 % ("pki_client_pkcs12_password",
-                                                                                     master['pki_user_deployment_cfg']))
+                                                                                     self.master_dict['pki_user_deployment_cfg']))
             # Verify existence of PKCS #12 Password (ONLY for Clones)
-            if config.str2bool(master['pki_clone']):
-                if not master.has_key('pki_clone_pkcs12_password') or\
-                   not len(master['pki_clone_pkcs12_password']):
+            if config.str2bool(self.master_dict['pki_clone']):
+                if not self.master_dict.has_key('pki_clone_pkcs12_password') or\
+                   not len(self.master_dict['pki_clone_pkcs12_password']):
                     config.pki_log.error(
                         log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
                         "pki_clone_pkcs12_password",
-                        master['pki_user_deployment_cfg'],
+                        self.master_dict['pki_user_deployment_cfg'],
                         extra = config.PKI_INDENTATION_LEVEL_2)
                     raise Exception(log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 % ("pki_clone_pkcs12_password",
-                                                                                         master['pki_user_deployment_cfg']))
+                                                                                         self.master_dict['pki_user_deployment_cfg']))
             # Verify existence of Security Domain Password File
             # (ONLY for Clones, KRA, OCSP, TKS, TPS, or Subordinate CA)
-            if config.str2bool(master['pki_clone']) or\
-               not master['pki_subsystem'] == "CA" or\
-               config.str2bool(master['pki_subordinate']):
-                if not master.has_key('pki_security_domain_password') or\
-                   not len(master['pki_security_domain_password']):
+            if config.str2bool(self.master_dict['pki_clone']) or\
+               not self.master_dict['pki_subsystem'] == "CA" or\
+               config.str2bool(self.master_dict['pki_subordinate']):
+                if not self.master_dict.has_key('pki_security_domain_password') or\
+                   not len(self.master_dict['pki_security_domain_password']):
                     config.pki_log.error(
                         log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
                         "pki_security_domain_password",
-                        master['pki_user_deployment_cfg'],
+                        self.master_dict['pki_user_deployment_cfg'],
                         extra = config.PKI_INDENTATION_LEVEL_2)
                     raise Exception(log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 % ("pki_security_domain_password",
-                                                                                          master['pki_user_deployment_cfg']))
+                                                                                          self.master_dict['pki_user_deployment_cfg']))
             # If required, verify existence of Token Password
-            if not master['pki_token_name'] == "internal":
-                if not master.has_key('pki_token_password') or\
-                   not len(master['pki_token_password']):
+            if not self.master_dict['pki_token_name'] == "internal":
+                if not self.master_dict.has_key('pki_token_password') or\
+                   not len(self.master_dict['pki_token_password']):
                     config.pki_log.error(
                         log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
                         "pki_token_password",
-                        master['pki_user_deployment_cfg'],
+                        self.master_dict['pki_user_deployment_cfg'],
                         extra = config.PKI_INDENTATION_LEVEL_2)
                     raise Exception(log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 % ("pki_token_password",
-                                                                                         master['pki_user_deployment_cfg']))
+                                                                                         self.master_dict['pki_user_deployment_cfg']))
         return
 
     def verify_mutually_exclusive_data(self):
         # Silently verify the existence of 'mutually exclusive' data
-        if master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
-            if master['pki_subsystem'] == "CA":
-                if config.str2bool(master['pki_clone']) and\
-                   config.str2bool(master['pki_external']) and\
-                   config.str2bool(master['pki_subordinate']):
+        if self.master_dict['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
+            if self.master_dict['pki_subsystem'] == "CA":
+                if config.str2bool(self.master_dict['pki_clone']) and\
+                   config.str2bool(self.master_dict['pki_external']) and\
+                   config.str2bool(self.master_dict['pki_subordinate']):
                     config.pki_log.error(
                         log.PKIHELPER_MUTUALLY_EXCLUSIVE_CLONE_EXTERNAL_SUB_CA,
-                        master['pki_user_deployment_cfg'],
+                        self.master_dict['pki_user_deployment_cfg'],
                         extra = config.PKI_INDENTATION_LEVEL_2)
-                    raise Exception(log.PKIHELPER_MUTUALLY_EXCLUSIVE_CLONE_EXTERNAL_SUB_CA % master['pki_user_deployment_cfg'])
-                elif config.str2bool(master['pki_clone']) and\
-                     config.str2bool(master['pki_external']):
+                    raise Exception(log.PKIHELPER_MUTUALLY_EXCLUSIVE_CLONE_EXTERNAL_SUB_CA % self.master_dict['pki_user_deployment_cfg'])
+                elif config.str2bool(self.master_dict['pki_clone']) and\
+                     config.str2bool(self.master_dict['pki_external']):
                     config.pki_log.error(
                         log.PKIHELPER_MUTUALLY_EXCLUSIVE_CLONE_EXTERNAL_CA,
-                        master['pki_user_deployment_cfg'],
+                        self.master_dict['pki_user_deployment_cfg'],
                         extra = config.PKI_INDENTATION_LEVEL_2)
-                    raise Exception(log.PKIHELPER_MUTUALLY_EXCLUSIVE_CLONE_EXTERNAL_CA % master['pki_user_deployment_cfg'])
-                elif config.str2bool(master['pki_clone']) and\
-                     config.str2bool(master['pki_subordinate']):
+                    raise Exception(log.PKIHELPER_MUTUALLY_EXCLUSIVE_CLONE_EXTERNAL_CA % self.master_dict['pki_user_deployment_cfg'])
+                elif config.str2bool(self.master_dict['pki_clone']) and\
+                     config.str2bool(self.master_dict['pki_subordinate']):
                     config.pki_log.error(
                         log.PKIHELPER_MUTUALLY_EXCLUSIVE_CLONE_SUB_CA,
-                        master['pki_user_deployment_cfg'],
+                        self.master_dict['pki_user_deployment_cfg'],
                         extra = config.PKI_INDENTATION_LEVEL_2)
-                    raise Exception(log.PKIHELPER_MUTUALLY_EXCLUSIVE_CLONE_SUB_CA % master['pki_user_deployment_cfg'])
-                elif config.str2bool(master['pki_external']) and\
-                     config.str2bool(master['pki_subordinate']):
+                    raise Exception(log.PKIHELPER_MUTUALLY_EXCLUSIVE_CLONE_SUB_CA % self.master_dict['pki_user_deployment_cfg'])
+                elif config.str2bool(self.master_dict['pki_external']) and\
+                     config.str2bool(self.master_dict['pki_subordinate']):
                     config.pki_log.error(
                         log.PKIHELPER_MUTUALLY_EXCLUSIVE_EXTERNAL_SUB_CA,
-                        master['pki_user_deployment_cfg'],
+                        self.master_dict['pki_user_deployment_cfg'],
                         extra = config.PKI_INDENTATION_LEVEL_2)
-                    raise Exception(log.PKIHELPER_MUTUALLY_EXCLUSIVE_EXTERNAL_SUB_CA % master['pki_user_deployment_cfg'])
+                    raise Exception(log.PKIHELPER_MUTUALLY_EXCLUSIVE_EXTERNAL_SUB_CA % self.master_dict['pki_user_deployment_cfg'])
 
     def verify_predefined_configuration_file_data(self):
         # Silently verify the existence of any required 'predefined' data
